/****************************************************************/
/*   draw_graph.c	      					*/
/****************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "xad.h"

#define	WINDOW_HEIGHT	600
#define	WINDOW_WIDTH	600
#define FONT_NAME       "9x15"

extern Display	*theDisplay;
extern Window	theWindow;
extern GC	theGC;
extern int	theScreen;
extern int	theDepth;
int		entries,set;
XArc		*the_arcs;
XFontStruct     *font_struct;
char            string[20], str[10];


#ifdef	NO_FORTRAN_HASH
dp_initialize(void)
#else NO_FORTRAN_HASH
dp_initialize_(void)
#endif NO_FORTRAN_HASH
{
	xad_open_window(100,100,WINDOW_HEIGHT,WINDOW_WIDTH,
                        XAD_WT_1_BW,"Draw_Graph");
	XClearWindow(theDisplay,theWindow);
	XFlush(theDisplay);
}

#ifdef	NO_FORTRAN_HASH
dp_draw_graph(float X1[], float V1[], 
              float X2[], float V2[], int *ent)
#else NO_FORTRAN_HASH
dp_draw_graph_(float X1[], float V1[], 
               float X2[], float V2[], int *ent)
#endif NO_FORTRAN_HASH
{
	int	i,j;
	float	x_point;
	float	y_point;

	free(the_arcs);
	entries=(*ent);
	the_arcs=(XArc *)malloc(sizeof(XArc)*entries);

	XClearArea(theDisplay,theWindow,0,0,
                   WINDOW_HEIGHT,WINDOW_WIDTH,False);

        /* Drawing Axes */
        XDrawLine(theDisplay,theWindow,theGC,100,100,100,550);   /* y axis */
        XDrawLine(theDisplay,theWindow,theGC,40,350,500,350);    /* x axis */

        /* Drawing Text (label axes) */
        font_struct=XLoadQueryFont(theDisplay, FONT_NAME);
        XSetFont(theDisplay, theGC, font_struct->fid);
        (void) strcpy(string, "V");
        XDrawImageString(theDisplay,theWindow,theGC,
                         85,90,string,strlen(string));
        (void) strcpy(string, "X");
        XDrawImageString(theDisplay,theWindow,theGC,
                         510,353,string,strlen(string));
        (void) strcpy(string, "X1");
        XDrawImageString(theDisplay,theWindow,theGC,
                         150,320,string,strlen(string));
        (void) strcpy(string, "X2");
        XDrawImageString(theDisplay,theWindow,theGC,
                         400,320,string,strlen(string));


        /* Drawing Graph */
        /* set=1 ; Draw X1 positions
           set=2 ; Draw X2 positions */
        for(set=1;set<=2;++set)
	  {
	    for(i=0;i<*ent;++i)
	      {
		if(set==1)  {
		  x_point=X1[i];
		  y_point=V1[i];
		  the_arcs[i].x=x_point*130+100;
		}
		else  {
		  x_point=X2[i];
		  y_point=V2[i];
		  the_arcs[i].x=x_point*130-50;
		}
                the_arcs[i].y=350-y_point*150;
		the_arcs[i].width=3;
		the_arcs[i].height=3;
		the_arcs[i].angle1=0;
                the_arcs[i].angle2=23040;
                                
                /* Print point values */
		if(x_point==0.) {   /* Print initial V value */
		  (void) strcpy(string, "V=");
                  sprintf(str, "%3.1f",y_point);
                  strcat(string,str);
		  XDrawImageString(theDisplay, theWindow, theGC,
                                   the_arcs[i].x-50, the_arcs[i].y+3,
                                   string, strlen(string));
                  (void) strcpy(string, "4.0");
                  XDrawImageString(theDisplay, theWindow, theGC,
                                   460, 380, string, strlen(string));
		}
		if((set==1) && (i==*ent-1)) {
		  (void) strcpy(string, "V=");
                  sprintf(str, "%3.1f",y_point);
                  strcat(string,str);
		  XDrawImageString(theDisplay, theWindow, theGC,
                                   the_arcs[i].x-58, the_arcs[i].y+5,
                                   string, strlen(string));
		}
                /* Print X vaule when V=0 */ 
                if((set==1) && (V1[i]<=0) && (V1[i-1]>=0)) {
                  sprintf(string, "%4.2f",x_point);
		  XDrawImageString(theDisplay, theWindow, theGC,
                                   the_arcs[i].x-10, the_arcs[i].y+30,
                                   string, strlen(string));
		}
                if((set==2) && (V2[i]>=0) && (V2[i-1]<=0)) {
                  sprintf(string, "%4.2f",x_point);
		  XDrawImageString(theDisplay, theWindow, theGC,
                                   the_arcs[i].x-15, the_arcs[i].y+30,
                                   string, strlen(string));
		}
	      
	      }
	    XFillArcs(theDisplay,theWindow,theGC,the_arcs,entries); 
	  }
	XFlush(theDisplay); 
     
}














